;*********************************************************
;SG OSC 05  400Hz & 1000Hz AF OSC (FOR 9851DDS SG AM MODUDATION)
;CPU AT90S1200    2004.4.3  BY JE1UCI
;*********************************************************

.include "1200def.inc"
 
;**** regster set ****

.DEF		TEMP	= R16
.DEF		TIM	= R17
.DEF		TIM1	= R18
.DEF		TIM2	= R19



.CSEG
.ORG 0


;****reset vector and interrupt vector set *************************************************************************

		RJMP	RESET
		RJMP	RESET
		RJMP	RESET
		RJMP	RESET

RESET:		
		LDI	TIM,$00
		




		LDI	TEMP,$FF	;PORTB=ALL OUT (0-7)
		OUT	DDRB,TEMP
		
		LDI	TEMP,$00	;PORTD=ALL IN (0-6)
		OUT	DDRD,TEMP
		LDI	TEMP,$7F	;PORTD=PULL UP
		OUT	PORTD,TEMP

;****  M A I N *****************************************************************************************************
MAIN00:		LDI	TEMP,$7F
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN01:		LDI	TEMP,$86
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN02:		LDI	TEMP,$8E
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN03:		LDI	TEMP,$96
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN04:		LDI	TEMP,$9E
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN05:		LDI	TEMP,$A6
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN06:		LDI	TEMP,$AD
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN07:		LDI	TEMP,$B5
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN08:		LDI	TEMP,$BC
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN09:		LDI	TEMP,$C3
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN10:		LDI	TEMP,$C9
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN11:		LDI	TEMP,$CF
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN12:		LDI	TEMP,$D5
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN13:		LDI	TEMP,$DB
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN14:		LDI	TEMP,$E0
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN15:		LDI	TEMP,$E5
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN16:		LDI	TEMP,$EA
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN17:		LDI	TEMP,$EE
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN18:		LDI	TEMP,$F1
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN19:		LDI	TEMP,$F5
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN20:		LDI	TEMP,$F7
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN21:		LDI	TEMP,$FA
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN22:		LDI	TEMP,$FB
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN23:		LDI	TEMP,$FC
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN24:		LDI	TEMP,$FD
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN25:		LDI	TEMP,$FE
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN26:		LDI	TEMP,$FD
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN27:		LDI	TEMP,$FC
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN28:		LDI	TEMP,$FB
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN29:		LDI	TEMP,$FA
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN30:		LDI	TEMP,$F7
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN31:		LDI	TEMP,$F5
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN32:		LDI	TEMP,$F1
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN33:		LDI	TEMP,$EE
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN34:		LDI	TEMP,$EA
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN35:		LDI	TEMP,$E5
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN36:		LDI	TEMP,$E0
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN37:		LDI	TEMP,$DB
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN38:		LDI	TEMP,$D5
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN39:		LDI	TEMP,$CF
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN40:		LDI	TEMP,$C9
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN41:		LDI	TEMP,$C3
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN42:		LDI	TEMP,$BC
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN43:		LDI	TEMP,$B5
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN44:		LDI	TEMP,$AD
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN45:		LDI	TEMP,$A6
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN46:		LDI	TEMP,$9E
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN47:		LDI	TEMP,$96
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN48:		LDI	TEMP,$8E
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN49:		LDI	TEMP,$86
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN50:		LDI	TEMP,$7F
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN51:		LDI	TEMP,$77
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN52:		LDI	TEMP,$6F
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN53:		LDI	TEMP,$67
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN54:		LDI	TEMP,$5F
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN55:		LDI	TEMP,$57
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN56:		LDI	TEMP,$50
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN57:		LDI	TEMP,$48
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN58:		LDI	TEMP,$41
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN59:		LDI	TEMP,$3A
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN60:		LDI	TEMP,$34
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN61:		LDI	TEMP,$2E
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN62:		LDI	TEMP,$28
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN63:		LDI	TEMP,$22
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN64:		LDI	TEMP,$1D
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN65:		LDI	TEMP,$18
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN66:		LDI	TEMP,$13
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN67:		LDI	TEMP,$0F
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN68:		LDI	TEMP,$0C
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN69:		LDI	TEMP,$08
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN70:		LDI	TEMP,$06
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN71:		LDI	TEMP,$03
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN72:		LDI	TEMP,$02
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN73:		LDI	TEMP,$01
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN74:		LDI	TEMP,$00
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN75:		LDI	TEMP,$00
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN76:		LDI	TEMP,$00
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN77:		LDI	TEMP,$01
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN78:		LDI	TEMP,$02
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN79:		LDI	TEMP,$03
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN80:		LDI	TEMP,$06
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN81:		LDI	TEMP,$08
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN82:		LDI	TEMP,$0C
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN83:		LDI	TEMP,$0F
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN84:		LDI	TEMP,$13
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN85:		LDI	TEMP,$18
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN86:		LDI	TEMP,$1D
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN87:		LDI	TEMP,$22
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN88:		LDI	TEMP,$28
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN89:		LDI	TEMP,$2E
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN90:		LDI	TEMP,$34
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN91:		LDI	TEMP,$3A
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN92:		LDI	TEMP,$41
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN93:		LDI	TEMP,$48
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN94:		LDI	TEMP,$50
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN95:		LDI	TEMP,$57
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN96:		LDI	TEMP,$5F
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN97:		LDI	TEMP,$67
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN98:		LDI	TEMP,$6F
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN99:		LDI	TEMP,$77
		OUT	PORTB,TEMP
		RCALL	TIMER

MAIN_END:	RJMP	MAIN00

;*** TIMER *******************************************************
TIMER:		IN	TEMP,PIND
		ANDI	TEMP,$7F
		CPI	TEMP,$7F
		BREQ	TIMER
		CPI	TEMP,$7E
		BREQ	TIMER_1K
		CPI	TEMP,$7D
		BREQ	TIMER_400
		RJMP	TIMER


TIMER_1K:	LDI	TIM,$0B
		DEC	TIM
TIMER_1K_LOOP:	NOP
		NOP
		NOP
		NOP
		NOP
		DEC	TIM
		BRNE	TIMER_1K_LOOP
TIMER_1K_TUNE:	NOP		
		NOP
		NOP
		NOP
		NOP
		NOP
		RET	

TIMER_400:	LDI	TIM,$1E
		DEC	TIM
TIMER_400_LOOP:	NOP
		NOP
		NOP
		NOP
		NOP
		DEC	TIM
		BRNE	TIMER_400_LOOP
TIMER_400_TUNE:	NOP
		NOP
		NOP
		RET		





;**** End of File ************************************************

